package cn.dankal.code.util.test;

import cn.dankal.code.util.entity.ProjectInfo;
import cn.hutool.core.io.FileUtil;
import org.junit.After;
import org.junit.Before;
import org.junit.Ignore;
import org.junit.Test;

import java.io.File;

/**
 * 功能测试
 *
 * @author ZGH.MercyModest
 * @version V1.0.0
 * @create 2020/10/30
 */
public class FunctionTest {

    /**
     * 项目信息对象
     */
    private ProjectInfo projectInfo;

    @Before
    public void beforeTests() {
        // 项目名称
        final String projectName = "test-in-code-util";

        // 项目基础包名  etc. cn.dankal
        final String basePackageName = "cn.dankal.test.code";

        // 项目描述   etc.蛋壳创意科技--微服务--简易代码生成器
        final String projectDescription = "蛋壳创意科技--微服务--简易代码生成器测试项目";

        // 模板项目路径 : C:\dev\test  目前只支持一套模板
        final String templateProjectPath = "C:/dev/test/dankal-microservice-code-template";

        // 项目生成路径  C:\dev\test
        final String projectCreatePath = "C:/dev/test";

        //创建生成项目路径
        String projectPath = projectCreatePath + File.separator + projectName;
        File file = new File(projectPath);
        if (file.exists()) {
            FileUtil.del(file);
        }
        boolean mkdir = file.mkdir();
        if (!mkdir) {
            throw new IllegalStateException("创建新项目目录失败");
        }
        this.projectInfo = new ProjectInfo()
                .setProjectName(projectName)
                .setProjectCreatePath(projectCreatePath)
                .setProjectDescription(projectDescription)
                .setBasePackageName(basePackageName)
                .setTemplateProjectPath(templateProjectPath)
                .setProjectPath(projectPath);
    }

    @Test
    @Ignore
    public void testLoopFileByHutool() {
        FileUtil.loopFiles(projectInfo.getTemplateProjectPath()).forEach(System.out::println);
    }

    @After
    public void after() {
        this.projectInfo = null;
    }
}
